Bug 558181

Summary: nfsv4 opening file with O_CREAT|O_EXCL = -EPERM
Product: [Fedora] Fedora Reporter: Rudd-O DragonFear <rudd-o>
Component: nfs-utilsAssignee: Steve Dickson <steved>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: 13CC: jlayton, steved
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-06-27 10:50:52 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description Rudd-O DragonFear 2010-01-24 01:58:50 EST
if a filesystem is mounted with nfsv4 (-t nfs4) on a fedora client, and that filesystem is being served on a fedora server, then I cannot logon to KDE.  this is because both gdm and the KDE session attempt to create files upon login with O_EXCL on the home directory, and nfsv4 fails that operation (though it DOES create the files, with 0 permission)

exactly the same bug as here:
http://bugs.centos.org/view.php?id=3840

so nfsv4 is broken on fedora 12, even though there seems to be a patch for the kernel that would solve the problem.

(all fedora 12)

client:
10.254.102.1:/home       /home            nfs4    _netdev         0 0

server:
/export/home  -fsid=1,mp,insecure,ro,no_root_squash   vmopslaptop-eth(rw) vmopslaptop-wlan(rw)
Comment 1 Jeff Layton 2010-01-24 07:26:37 EST
The patch that fixed that in RHEL has been upstream for a long time. If you're seeing this problem then it's likely to be unrelated.

In fact, I suspect that the problem is more likely to be something with ID mapping. I'd start by checking that /etc/idmapd.conf are both using the same setting for "Domain =".
Comment 2 Steve Dickson 2010-01-25 09:18:06 EST
Are there any error message being logged to /var/log/messages?
Comment 3 Rudd-O DragonFear 2010-01-25 12:40:20 EST
No error messages at all.  There is no problem with ID mapping -- idmapd correctly maps existing users on the server to existing users on the laptop that mounts the NFS share.  The underlying filesystem is ZFS-FUSE (this should not make a difference, though).  The patch MAY be in RHEL, but it is certainly not (or it is ineffective) in the Fedora kernel 2.6.31.12-174 (x86_64).

Oh, one more data point: nfsv3 works well.

Aside from the continuous stream of ESTALEs that I somehow suspect is caused by ZFS-FUSE.  But that's a separate rabbit hole and I'm going in there with a shotgun myself later.
Comment 4 Jeff Layton 2010-01-25 12:54:56 EST
I'm stumped then...

It sounds like you're able to do a CREATE operation, but are maybe then failing to open the file and write to it afterward. My suspicion again would be a problem with ID mapping, but maybe it's something else. Maybe capturing some network traffic would help you to determine the cause?

Either way, I don't think it's related to the RHEL bug you referenced, even if the symptoms are similar...
Comment 5 Rudd-O DragonFear 2010-01-25 13:01:23 EST
OK open(O_EXCL|O_CREAT) operation fails, but the file itself is indeed created (albeit with zero permissions).

I will attempt to capture network traffic to see this issue from the NFS standpoint.  Let's hope my machine doesn't freeze like it did when I ran wireshark last time.
Comment 6 Steve Dickson 2010-01-25 14:53:57 EST
try using tshark.... something like 

   tshark -o /tmp/data.pcap host <server>

then bzip2 the data.pcap file and post the file as
a data file
Comment 7 Bug Zapper 2010-03-15 10:12:02 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 13 development cycle.
Changing version to '13'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Rudd-O DragonFear 2010-08-03 22:17:49 EDT
The problem persists on Fedora 13.  Ask me for more info if you need.
Comment 9 Rudd-O DragonFear 2010-08-03 22:18:17 EDT
for the record, not even cp works from /path/somewhere to /nfs/mount/folder/where/i/have/write/permissions
Comment 11 Steve Dickson 2010-10-15 15:33:39 EDT
A network trace would help debug this...
Comment 12 Steve Dickson 2010-10-15 18:51:49 EDT
Here latest nfs-utils release

https://admin.fedoraproject.org/updates/nfs-utils-1.2.2-6.fc13

Please download test to see if you are still able to see this problem

tia...
Comment 13 Bug Zapper 2011-06-02 12:46:22 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 14 Bug Zapper 2011-06-27 10:50:52 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.